#  (gH)   --  galg2java.pm  ;  TimeStamp (unix) : 12 Septembre 01 15:15
#
##########################################################################
#
# Premire version : Benot LAURENT & Emmanuel LONG
#
##########################################################################
#
# Dclarations du package

package galg2java ;

require Exporter;
@ISA=('Exporter');
@EXPORT=(
	 'DebutProgramme_java',
	 'Commentaire_java',
	 'Affecter_java',
	 'Ecrire_java',
	 'Ecrire__java',
	 'Ecrire_sur_java',
	 'Lire_java',
	 'Lire_sur_java',
	 'Ouvrir_lec_java',
	 'Ouvrir_ecr_java',
	 'Fermer_java',
	 'Appeler_java',
	 'Quitter_java',
	 'Pour_java',
	 'Fin_Pour_java',
	 'Si_java',
	 'Alors_java',
	 'Sinon_java',
	 'Fin_Si_java',
	 'Tant_Que_java',
	 'Fin_Tant_Que_java',
	 'GereOperateur_java',
	 'GereFonction_java',
	 'GereVarSimple_java',
	 'GereVarTableau_java',
	 'GereChaine_java',
	 'GereCstNum_java',
	 'FinProgramme_java'
	);

##########################################################################

# Modules utiliss

use galgfncs ;

##########################################################################
##########################################################################


###########################################################################
#                                                                         #
#                                                                         #
#        Gestion de DEBUT et FIN de programme                             #
#                                                                         #
#                                                                         #
###########################################################################


#  %TVarType : Tableau contenant les VARiables et leur TYPE dans le langage
#  %TTabType : Tableau contenant les TABleaux et leur TYPE dans le langage

##########################################################################

sub DebutProgramme_java {

  print $::SymbFLang  "class $main::baseNomFichier { \n\n";
##  print $::SymbFLang  "public static void main (String args[ ]) { \n" ;
##  print  $::SymbFLang "// dbut de la mthode main() \n";


} ; # FIN sub DebutProgramme_java

##########################################################################

sub FinProgramme_java {

  print $::SymbFLang "} // fin de la mthode main()\n";
  print $::SymbFLang "} // fin de la classe $main::baseNomFichier \n";

} ; # FIN sub FinProgramme_java

##########################################################################
##########################################################################


###########################################################################
#                                                                         #
#                                                                         #
#        Sous-programmes de type INSTRUCTION                              #
#                                                                         #
#                                                                         #
###########################################################################


###########################################################################
###########################################################################


sub Commentaire_java {

  print $::SymbFLang "//".$_[0];

} ; # FIN sub Commentaire_java

##########################################################################

sub Affecter_java {

  my $expAff = $_[1] ;
  print $::SymbFLang $_[0]." = ".&convertitExpression_java( $expAff )." ;";

} ; # FIN sub Affecter_java

##########################################################################

sub Ecrire_java {

  my $Phraz;
  $Phraz=$_[0];
  $Phraz=~s/$::SeparDon/+/g;

  print $::SymbFLang " System.out.println(".$Phraz.") ;\n";

} ; # FIN sub Ecrire_java

##########################################################################


sub Ecrire__java {

  my $Phraz;
  $Phraz=$_[0];
  $Phraz=~s/$::SeparDon/+/g;

  print $::SymbFLang " System.out.print(".$Phraz.") ;\n";

} ; # FIN sub Ecrire_java

##########################################################################

sub Ecrire_sur_java {

  my $Phraz;
  $Phraz=$_[0];
  $Phraz=~s/$::SeparDon/+/g;

  print $::SymbFLang "$_[1].println(".$Phraz.") ;\n";

} ; # FIN sub Ecrire_java

##########################################################################

sub Lire_java {

   print $::SymbFLang "   System.out.flush() ;\n" ;
   print $::SymbFLang "   try { \n" ;
   print $::SymbFLang "     BufferedReader clavier = \n" ;
   print $::SymbFLang "        new BufferedReader(new InputStreamReader(System.in)) ;\n" ;
   print $::SymbFLang "     ".$_[0]." = clavier.readLine() ; \n" ;
   print $::SymbFLang "   } // fin de try  ; }\n" ;
   print $::SymbFLang "   catch (IOException erreurES) { System.out.println(erreurES.getMessage()); }\n" ;

} ; # FIN sub Lire_java

##########################################################################

sub Lire_sur_java {

   print $::SymbFLang "  $_[0] = $_[1].readLine() ; " ;

} ; # FIN sub Lire_java

##########################################################################

sub Ouvrir_lec_java {

   print $::SymbFLang "  BufferedReader $_[1] =  new BufferedReader(new FileReader($_[0])) ; \n" ;
   print $::SymbFLang "  try { " ;

} ; # FIN sub Ouvrir_lec_java

##########################################################################

sub Ouvrir_ecr_java {

   print $::SymbFLang "  PrintWriter $_[1] =  new PrintWriter(new BufferedWriter(new FileWriter($_[0]))) ;\n" ;
   print $::SymbFLang "  try { " ;

} ; # FIN sub Ouvrir_ecr_java

##########################################################################

sub Fermer_java {

   print $::SymbFLang "   $_[1].close() ; \n" ;
   print $::SymbFLang " } // fin de try : surtout pas de ; \n" ;
   print $::SymbFLang " catch(IOException exc) {  \n" ;
   print $::SymbFLang "         System.out.println(\"Erreur de lecture/critre de fichier \");  \n" ;
   print $::SymbFLang "         exc.printStackTrace() ; \n" ;
   print $::SymbFLang "} ; // fin de catch  \n" ;

} ; # FIN sub Fermer_java

##########################################################################

sub Appeler_java {

  print $::SymbFLang $_[0]."; ";

} ; # FIN sub Appeler_java

##########################################################################

sub Quitter_java {

  print $::SymbFLang "System.exit( $_[0] ) ; " ;

} ; # FIN sub Quitter_java

##########################################################################

sub Pour_java {

  print $::SymbFLang "for (int ".$_[0]."=".$_[1]."; ".$_[0]."<=".$_[2]."; ".$_[0]."++) { ";

} ; # FIN sub Fin_Pour_java

##########################################################################

sub Fin_Pour_java {

  print $::SymbFLang "\} ; ";

} ; # FIN sub Fin_Pour_java

##########################################################################

sub Si_java {

  print $::SymbFLang "if (".$_[0].") { ";

} ; # FIN sub Si_java

##########################################################################

sub Alors_java {

} ; # FIN sub Si_java

##########################################################################

sub Sinon_java {

  print $::SymbFLang "}\nelse\n{ ";

} ; # FIN sub Si_java

##########################################################################

sub Fin_Si_java {

  print $::SymbFLang "\} ; ";

} ; # FIN sub Fin_Si_java

##########################################################################

sub Tant_Que_java {

  print $::SymbFLang "while (".$_[0].") { ";

} ; # FIN sub Tant_Que_java

##########################################################################

sub Fin_Tant_Que_java {

  print $::SymbFLang "\} ; ";

} ; # FIN sub Fin_Tant_Que_java

##########################################################################

##########################################################################
##
##  Fonctions de gestion des paramtres
##
##########################################################################

##########################################################################

sub GereOperateur_java {
  my $ExprD; # EXPRession Droite
  my $Op; # OPrateur
  my $ExprG; # EXPRession Gauche
  my %TCoresOp; # Tableau de CORrESpondance des Oprateurs

  $ExprD=$_[0];
  $Op=$_[1];
  $ExprG=$_[2];

  # Initialisation du Tableau de CORrESpondance des Oprateurs
  $TCoresOp{"_OU_"}="||";
  $TCoresOp{"_ET_"}="&&";
  $TCoresOp{"_NON_"}="!";
  $TCoresOp{"_INFEGAL_"}="<=";
  $TCoresOp{"_SUPEGAL_"}=">=";
  $TCoresOp{"_DIFF_"}="!=";
  $TCoresOp{"_EGAL_"}="==";
  $TCoresOp{"_INF_"}="<";
  $TCoresOp{"_SUP_"}=">";
  $TCoresOp{"_PLUS_"}="+";
  $TCoresOp{"_MOINS_"}="-";
  $TCoresOp{"_MULT_"}="*";
  $TCoresOp{"_DIV_"}="/";

  # Traduction de l'oprateur en Perl
  $Op=$TCoresOp{$Op} ;

  return($ExprD.$Op.$ExprG);

} ; # FIN sub GereOperateur_java

##########################################################################

# Non gr  ce jour : suivant le type retourn par la fonction(s'il y en a un), il faut la faire prcder d'un "&", "*"...

sub GereFonction_java {

  my  $Param;
  my  $nomF ;
  $nomF =$_[0];
  $Param=$_[1];

  # on traite  part fin_de_fichier

  if ($nomF ne "fin_de_fichier") {
      $Param=~s/$::SeparDon/, /g;
      $Param= &convertitExpression_java($Param) ;
      $retour = "$_[0]( $Param )" ;
  } else {
     $retour = "! ".$Param.".ready() " ;
  } ; # fin de si

  return($retour) ;

} ; # FIN sub GereFonction_java

##########################################################################

sub GereVarSimple_java {

  return($_[0]);

} ; # FIN sub GereVarSimple_java

##########################################################################

sub GereVarTableau_java {
  my $Param;

  $Param=$_[1];

  $Param=~s/$::SeparDon/  \]\[ /g;


  return($_[0]."[".$Param."]");

} ; # FIN sub GereVarTableau_java

##########################################################################

sub GereChaine_java {

  return("\"".$_[0]."\"");

} ; # FIN sub GereChaine_java

##########################################################################

sub GereCstNum_java {

  return($_[0]);

} ; # FIN sub GereCstNum_java

##########################################################################

sub  convertitExpression_java  {

  my $l_expression = $_[0] ;

  $l_expression =~ s/_OU_/ or /g ;
  $l_expression =~ s/_ET_/  and /g ;
  $l_expression =~ s/_NON_/  not /g ;
  $l_expression =~ s/_INFEGAL_/ <= /g  ;
  $l_expression =~ s/_SUPEGAL_/ >= /g  ;
  $l_expression =~ s/_DIFF_/ <> /g ;
  $l_expression =~ s/_EGAL_/ = /g   ;
  $l_expression =~ s/_INF_/ < /g   ;
  $l_expression =~ s/_SUP_/ > /g   ;
  $l_expression =~ s/_PLUS_/ + /g   ;
  $l_expression =~ s/_MOINS_/ - /g   ;
  $l_expression =~ s/_MULT_/ * /g   ;
  $l_expression =~ s!_DIV_! / !g   ;

  return( $l_expression ) ;

} ; # fin sub convertitExpression_java

##########################################################################

##########################################################################
##
## Fin du module
##
##########################################################################

##########################################################################


# cette dernire ligne est obligatoire pour dire que le chargement est ok :

1;
