#  TimeStamp  (dos) : 25 Juillet 03 20:28  --  x:\galg\galgerr.pm

package galgerr  ;


###########################################################################


use lib $ENV{"PERL_MACROS"} ; # rpertoire des modules perl personnels
use galgfncs ; # Bibliothque de fonctions utiles sur chaines


###########################################################################
###########################################################################


###########################################################################
##                                                                        #
##      sous-programmes pour les Erreurs dtectes                        #
##                                                                        #
###########################################################################


###########################################################################
###########################################################################


sub codesErreur  {

  $main::ce["001"] = " la premire ligne du fichier-algorithme n'est pas un commentaire" ;
  $main::ce["002"] = " instruction inconnue (mot Un non reconnu)" ;
  $main::ce["003"] = " une instruction ECRIRE doit prcder l'instruction LIRE" ;
  $main::ce["004"] = " instruction ECRIRE incorrecte " ;
  $main::ce["005"] = " aprs LIRE il faut mettre le nom d'une variable" ;
  $main::ce["006"] = " une instruction LIRE ne lit qu'une variable  la fois " ;
  $main::ce["007"] = " partie gauche d'affectation incorrecte" ;
  $main::ce["008"] = " expression unique correcte requise" ;
  $main::ce["009"] = " identificateur gal au mot reserv 'A' ou 'DE' " ;
  $main::ce["010"] = " partie gauche de condition vide" ;
  $main::ce["011"] = " partie droite de condition vide" ;
  $main::ce["012"] = " instruction POUR incorrecte : fin_pour non comment" ;
  $main::ce["013"] = " instruction SI incorrecte : fin_si non comment" ;
  $main::ce["014"] = " instruction TANT_QUE incorrecte : fin_tant_que non comment" ;
  $main::ce["015"] = " opration incorrecte " ;
  $main::ce["016"] = " mauvaise imbrication des structures SI, POUR ou TANT_QUE" ;
  $main::ce["017"] = " trop de niveaux d'imbrication (maximum autoris : 3)" ;
  $main::ce["018"] = " expression mal parenthse" ;
  $main::ce["019"] = " mot-clef non autoris sur la mme ligne que ALORS ou SINON " ;
  $main::ce["020"] = " identificateur incorrect " ;
  $main::ce["021"] = " ALORS absent" ;
  $main::ce["022"] = " partie gauche de 'A' invalide dans boucle pour" ;
  $main::ce["023"] = " partie droite de 'A' invalide dans boucle pour" ;
  $main::ce["024"] = " ALORS/SINON mal plac " ;
  $main::ce["025"] = " on ne peut pas lire directement une valeur de tableau " ;
  $main::ce["026"] = " expression mal guillemetise" ;
  $main::ce["027"] = " expression mal crochetise" ;
  $main::ce["028"] = " affectation interdite dans instruction ECRIRE" ;
  $main::ce["029"] = " expression boolenne interdite dans instruction ECRIRE" ;
  $main::ce["030"] = " expression incorrecte ou calcul incorrect" ;
  $main::ce["031"] = " opration, liste ou test non termin " ;
  $main::ce["032"] = " appel de module sans parenthse ouvrante" ;
  $main::ce["033"] = " appel de module avec des caractres aprs la parenthse fermante " ;
  $main::ce["034"] = " syntaxe d'appel de module incorrecte" ;
  $main::ce["035"] = " identificateur homonyme d'un mot clef" ;
  $main::ce["036"] = " fin de structure incorrecte " ;
  $main::ce["037"] = " affectations multiples interdites sur une seule ligne " ;
  $main::ce["038"] = " trop de niveaux de parenthses " ;
  $main::ce["039"] = " instruction AFFECTER sans symbole <-- " ;
  $main::ce["040"] = " il doit manquer un paramtre " ;
  $main::ce["041"] = " il est interdit d'emboiter les crochets " ;
  $main::ce["042"] = " aucun appel de fonction n'est tolr  l'intrieur des crochets " ;
  $main::ce["043"] = " indice de tableau manquant " ;
  $main::ce["044"] = " partie gauche d'affectation de tableau incorrecte " ;
  $main::ce["045"] = " mot-clef ALORS en double " ;
  $main::ce["046"] = " mot-clef SINON en double " ;
  $main::ce["047"] = " partie droite d'affectation incorrecte " ;
  $main::ce["048"] = " points-virgules illicites " ;
  $main::ce["049"] = " caractre(s) invalide(s) dans expression " ;
  $main::ce["050"] = " instruction non reconnue aprs ALORS/SINON " ;
  $main::ce["051"] = " mot 'DE' dans boucle POUR non vu ou mal plac" ;
  $main::ce["052"] = " partie 'DE' invalide dans boucle pour" ;
  $main::ce["053"] = " arit du module incohrent avec arit prcdente" ;
  $main::ce["054"] = " dimensions du tableau incohrentes avec dimensions prcdentes" ;
  $main::ce["055"] = " il manque le mot COMME dans l'instruction OUVRIR" ;
  $main::ce["056"] = " il manque le mot EN_LECTURE ou EN_ECRITURE dans l'instruction OUVRIR" ;
  $main::ce["057"] = " pas de nom d'auteur fourni dans les 5 premires lignes de l'algorihtme" ;
  $main::ce["058"] = " les structures SI, POUR, REPETER et TANT_QUE ne sont pas toutes finies." ;
  $main::ce["059"] = " l'algorithme ne comporte aucune instruction. " ;
  $main::ce["060"] = " ALORS mal plac " ;

  $nbCodesE = 60 ;

} ; # fin sub codesErreur


###########################################################################
###########################################################################


sub listeDesErreurs  {

  &galgerr::codesErreur() ; # (r)initialisation de la liste des codes d'erreurs
  my $ier = 1 ; # indic d'erreur rencontre

  print "\n Liste des erreurs reconnues \n\n" ;

  while ($ier<=$nbCodesE) {
    $f_ier = sprintf("%03d",$ier) ;
    print "  $f_ier : ".$main::ce[$f_ier]."\n" ;
    $ier++;
  } ; # fin tant que sur ier

  print "\n -- fin de la liste des erreurs reconnues \n\n" ;
  print "  Les fichier testNN.alg sur le site Web permettent de voir les erreurs NN.\n\n" ;

} ; # fin sub listeDesErreurs


###########################################################################
###########################################################################


sub erreur  {  my $dbg_Err = 0 ; # 0 pour normal, 1 pour debug

  # ce sous-programme comptabilise une erreur de plus
  # et met le format d'erreur en mode toile
  # le code_erreur prend alors la valeur du paramtre

  # si la ligne contient dj une erreur, on ne fait rien

  if ($main::f_err ne "***") {

     $main::nbErreurs++ ;
     if ($dbg_Err==1) { print "  Erreur numro :    $main::nbErreurs, code $_[0] ligne $galganl::iLigneAlgo\n\n" ; } ;
     $main::f_err = "***" ;
     $main::c_err = $_[0] ;

  } ; # fin de si pas d'erreur dj prsente

} ; # fin sub erreur


###########################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :

1 ;
