#  (gH)   --  galg2c.pm  ;  TimeStamp (unix) : 12 Septembre 01 15:03
#
##########################################################################
#
# Premire version : Benot LAURENT & Emmanuel LONG
#
##########################################################################
#
# Dclarations du package

package galg2c ;

require Exporter;
@ISA=('Exporter');
@EXPORT=(
	 'DebutProgramme_c',
	 'Commentaire_c',
	 'Affecter_c',
	 'Ecrire_c',
	 'Ecrire__c',
	 'Ecrire_sur_c',
	 'Ouvrir_lec_c',
	 'Ouvrir_ecr_c',
	 'Fermer_c',
	 'Lire_c',
	 'Lire_sur_c',
	 'Appeler_c',
	 'Pour_c',
	 'Fin_Pour_c',
	 'Si_c',
	 'Alors_c',
	 'Sinon_c',
	 'Fin_Si_c',
	 'Tant_Que_c',
	 'Fin_Tant_Que_c',
	 'Repeter_c',
	 'Jusqu\'a_c',
	 'Quitter_c',
	 'GereOperateur_c',
	 'GereFonction_c',
	 'GereVarSimple_c',
	 'GereVarTableau_c',
	 'GereChaine_c',
	 'GereCstNum_c',
	 'FinProgramme_c'
	);

##########################################################################

# Module utilis

use galgfncs ;

##########################################################################
##########################################################################


##########################################################################
#                                                                        #
#  Gestion de DEBUT et FIN de programme                                  #
#                                                                        #
##########################################################################

#  %TVarType : Tableau contenant les VARiables et leur TYPE dans le langage
#  %TTabType : Tableau contenant les TABleaux et leur TYPE dans le langage

##########################################################################

sub DebutProgramme_c {

  print $::SymbFLang "\n";
  print $::SymbFLang "#include <stdio.h>\n";
  print $::SymbFLang "#include <stdlib.h>\n";
  print $::SymbFLang "#include <stdarg.h>\n";
  print $::SymbFLang "#include <string.h>\n";
  print $::SymbFLang "#include <ctype.h>\n";
  print $::SymbFLang "#include <time.h>\n";
  print $::SymbFLang "#include <math.h>\n";
  print $::SymbFLang "\n typedef char chaine[250] ;\n";

} ; # FIN sub DebutProgramme_c

##########################################################################

sub FinProgramme_c {

  print $::SymbFLang "return(0);\n\} /* fin de main */ \n";

} ; # FIN sub FinProgramme_c

##########################################################################

##########################################################################
##
## sous-programmes INSTRUCTION
##
## Ecriture dans le fichier
##
##########################################################################

##########################################################################

sub Commentaire_c {

  print $::SymbFLang "/* ".$_[0]. " */" ;

} ; # FIN sub Commentaire_c

##########################################################################

sub Affecter_c {

  my $expAff = $_[1] ;
  print $::SymbFLang $_[0]." = ".&convertitExpression_c( $expAff )." ;";} ;

# FIN sub Affecter_c

##########################################################################

sub Ecrire_c {

   &Ecrire__c( $_[0] ) ;
   print $::SymbFLang "puts(\"\") ;";

} ; # FIN sub Ecrire_c

##########################################################################

sub Ecrire__c {

  @TPhraz=split($::SeparDon, $_[0]);

  foreach $Expr (@TPhraz) {
      print $::SymbFLang "printf(\"%s\",".$Expr.") ;";
  } ; # FIN_POUR toutes les EXPRessions de la PHRAse

} ; # FIN sub Ecrire__c


##########################################################################

sub Ecrire_sur_c {

  @TPhraz=split($::SeparDon, $_[0]);

  foreach $Expr (@TPhraz) {
      print $::SymbFLang "fprintf(".$_[1].",\"%s\",".$Expr.") ;\n";
  } ; # FIN_POUR toutes les EXPRessions de la PHRAse
  print $::SymbFLang "fprintf(".$_[1].",\"\\n\") ; \n" ;

} ; # FIN sub Ecrire__c


##########################################################################

sub Lire_c {

   print $::SymbFLang "fgets($_[0],250,stdin) ;";

} ; # FIN sub Lire_c

##########################################################################

sub Lire_sur_c {

   print $::SymbFLang "fgets($_[0],250,$_[1]) ;";

} ; # FIN sub Lire_c

##########################################################################

sub Ouvrir_lec_c {

   print $::SymbFLang "$_[1] = fopen($_[0],\"r\") ;";

} ; # FIN sub Ouvrir_lec_c

##########################################################################

sub Ouvrir_ecr_c {

   print $::SymbFLang "$_[1] = fopen($_[0],\"w\") ;";

} ; # FIN sub Ouvrir_ecr_c

##########################################################################

sub Fermer_c {

   print $::SymbFLang "fclose($_[1]) ;";

} ; # FIN sub Fermer_c

##########################################################################

sub Appeler_c {

  print $::SymbFLang $_[0]." ; ";

} ; # FIN sub Appeler_c

##########################################################################

sub Pour_c {

  print $::SymbFLang "for(".$_[0]."=".$_[1]."; ".$_[0]."<=".$_[2]."; ".$_[0]."++) { ";

} ; # FIN sub Fin_Pour_c

##########################################################################

sub Fin_Pour_c {

  print $::SymbFLang "\} ; ";

} ; # FIN sub Fin_Pour_c

##########################################################################

sub Si_c {

  print $::SymbFLang "if (".$_[0].") \{ ";

} ; # FIN sub Si_c

##########################################################################

sub Alors_c {

} ; # FIN sub Si_c

##########################################################################

sub Sinon_c {

  print $::SymbFLang "\} else \{ ";

} ; # FIN sub Si_c

##########################################################################

sub Fin_Si_c {

  print $::SymbFLang "\} ; ";

} ; # FIN sub Fin_Si_c

##########################################################################

sub Tant_Que_c {

  print $::SymbFLang "while (".$_[0].") \{ ";

} ; # FIN sub Tant_Que_c

##########################################################################

sub Fin_Tant_Que_c {

  print $::SymbFLang "\} ; ";

} ; # FIN sub Fin_Tant_Que_c

##########################################################################

sub Repeter_c {

  print $::SymbFLang " ###################################################################\n" ;
  print $::SymbFLang " ###                                                               #\n" ;
  print $::SymbFLang " ###   Instruction algorithmique : REPETER non traduite :          #\n" ;
  print $::SymbFLang " ###                                                               #\n" ;
  print $::SymbFLang " ###       il n'y a pas de repeter...jusqu'a en C                  #\n" ;
  print $::SymbFLang " ###                                                               #\n" ;
  print $::SymbFLang " ###################################################################\n" ;


} ; # FIN sub Repeter_c

##########################################################################

sub Jusqu'a_c {

  print $::SymbFLang " ###################################################################\n" ;
  print $::SymbFLang " ###                                                               #\n" ;
  print $::SymbFLang " ###   Instruction algorithmique : JUSQU'A non traduite :          #\n" ;
  print $::SymbFLang " ###                                                               #\n" ;
  print $::SymbFLang " ###       il n'y a pas de repeter...jusqu'a en C                  #\n" ;
  print $::SymbFLang " ###                                                               #\n" ;
  print $::SymbFLang " ###################################################################\n" ;


} ; # FIN sub Jusqu'a_c

##########################################################################

sub Quitter_c {

  print $::SymbFLang "exit( $_[0] ) ; \n";

} ; # FIN sub Jusqu'a_c

##########################################################################

##########################################################################
##
##  Fonctions de gestion des paramtres
##
##########################################################################

##########################################################################

sub GereOperateur_c {
  my $ExprD; # EXPRession Droite
  my $Op; # OPrateur
  my $ExprG; # EXPRession Gauche
  my %TCoresOp; # Tableau de CORrESpondance des Oprateurs

  $ExprD=$_[0];
  $Op=$_[1];
  $ExprG=$_[2];

  # Initialisation du Tableau de CORrESpondance des Oprateurs
  $TCoresOp{"_OU_"}="||";
  $TCoresOp{"_ET_"}="&&";
  $TCoresOp{"_NON_"}="!";
  $TCoresOp{"_INFEGAL_"}="<=";
  $TCoresOp{"_SUPEGAL_"}=">=";
  $TCoresOp{"_DIFF_"}="!=";
  $TCoresOp{"_EGAL_"}="==";
  $TCoresOp{"_INF_"}="<";
  $TCoresOp{"_SUP_"}=">";
  $TCoresOp{"_PLUS_"}="+";
  $TCoresOp{"_MOINS_"}="-";
  $TCoresOp{"_MULT_"}="*";
  $TCoresOp{"_DIV_"}="/";

  # Traduction de l'oprateur en Perl
  $Op=$TCoresOp{$Op} ;

  return($ExprD.$Op.$ExprG);

} ; # FIN sub GereOperateur_c

##########################################################################

# Non gr  ce jour : suivant le type retourn par la fonction(s'il y en a un), il faut la faire prcder d'un "&", "*"...

sub GereFonction_c {
  my  $Param;

  $Param=$_[1];

  $Param=~s/$::SeparDon/, /g;

  return($_[0]."(".$Param.")");

} ; # FIN sub GereFonction_c

##########################################################################

sub GereVarSimple_c {

  return($_[0]);

} ; # FIN sub GereVarSimple_c

##########################################################################

sub GereVarTableau_c {
  my $Param;

  $Param=$_[1];
  $Param=~s/$::SeparDon/  \]\[ /g;
  return($_[0]."[".$Param."]");

} ; # FIN sub GereVarTableau_c

##########################################################################

sub GereChaine_c {

  return("\"".$_[0]."\"");

} ; # FIN sub GereChaine_c

##########################################################################

sub GereCstNum_c {

  return($_[0]);

} ; # FIN sub GereCstNum_c

##########################################################################

sub  convertitExpression_c  {

  my $l_expression = $_[0] ;

  $l_expression =~ s/_OU_/ || /g ;
  $l_expression =~ s/_ET_/  && /g ;
  $l_expression =~ s/_NON_/  ! /g ;
  $l_expression =~ s/_INFEGAL_/ <= /g  ;
  $l_expression =~ s/_SUPEGAL_/ >= /g  ;
  $l_expression =~ s/_DIFF_/ != /g ;
  $l_expression =~ s/_EGAL_/ == /g   ;
  $l_expression =~ s/_INF_/ < /g   ;
  $l_expression =~ s/_SUP_/ > /g   ;
  $l_expression =~ s/_PLUS_/ + /g   ;
  $l_expression =~ s/_MOINS_/ - /g   ;
  $l_expression =~ s/_MULT_/ * /g   ;
  $l_expression =~ s!_DIV_! / !g   ;

  return( $l_expression ) ;

} ; # fin sub convertitExpression_c

##########################################################################
##########################################################################


##########################################################################
##
##   version prliminaire pour typage :
##
##########################################################################


sub DemandeType {
  my @TCoresType; # Tableau de CORrESpondance entre le TYPE donn par l'utilisateur et le TYPE dans le langage
  my @TLVarTab; # Tableau contenant la Liste des VARiables ou des TABleaux
  my $VarTab; # VARiable ou TABleau
  my $Type;
  my $TailleCh; # TAILLE de la CHaine de caractre
  my $TailleTab; # TAILLE du TABeau

  @TCoresType=("float", "char");

  if ($::LVar ne "") {
    print "Vous avez choisi de traduire votre algorithme dans le langage C.\n";
    print "Vous devez typer vos variables.\n";
    print "Types existants :\n0 : nombre\n1 : chaine de caractres\n";
    print "Entrez le nombre correspondant  votre choix\n";

    @TLVarTab=split(" ", $::LVar);
    foreach $VarTab (@TLVarTab) {
      # criture de la variable  traiter, rcupration du type
      $Type=-1;
      while (($Type != 0) and ($Type != 1)) {
	print "$VarTab => ";
	chomp($Type=<STDIN>);
      } ; # fin_tant_que mauvais type

      # enregistrement de la VARiable et de son TYPE
      if ($Type == 1) {
	print "Prcisez la taille de votre chaine de caractres : ";
	chomp($TailleCh=<STDIN>);
	$TVarType{$VarTab}=$TCoresType[$Type].$::SeparDon."[".$TailleCh."]";
      }
      else {
	$TVarType{$VarTab}=$TCoresType[$Type];
      } ; # fin_si la Variable est une chaine de caractre

      print "\n";
    } ; # Fin_Pour toutes les variables
  } ; # FIN_SI la Liste des VARiables n'est pas vide

  if ($::LTab ne "") {
    print "Vous devez typer vos tableaux.\n";
    print "Types existants :\n0 : nombre\n1 : chaine de caractres\n";
    print "Entrez le nombre correspondant  votre choix\n";

    @TLVarTab=split(" ", $::LTab);
    foreach $VarTab (@TLVarTab) {
      # criture du tableau  traiter, rcupration du type et de la taille
      $Type=-1;
      while (($Type != 0) and ($Type != 1)) {
	print "$VarTab => ";
	chomp($Type=<STDIN>);
      } ; # fin_tant_que mauvais type
      print "Prcisez le nombre d'lments de votre tableau : ";
      chomp($TailleTab=<STDIN>);
      if ($Type == 1) {
	print "Vous avez choisi un tableau form de chaines de caractres, prcisez leur taille : ";
	chomp($TailleCh=<STDIN>);
	$TTabType{$VarTab}=$TCoresType[$Type].$::SeparDon."[".$TailleTab."]"."[".$TailleCh."]";
      }
      else {
	$TTabType{$VarTab}=$TCoresType[$Type].$::SeparDon."[".$TailleTab."]";
      } ; # fin_si le tableau contient des chaines de caractres

      print "\n";
    } ; # Fin_Pour tous les tableaux
  } ; # FIN_SI la Liste des TABleaux n'est pas vide

} ; # FIN sub DemandeType

##########################################################################

sub EnTete {
  my $Var;
  my @TType_TailleChTab; # Tableau contenant le type puis la TAILLE de la CHaine et/ou du TABleau

  foreach $Var (keys %TVarType) {
    @TType_TailleChTab=split($::SeparDon, $TVarType{$Var});
    print $::SymbFLang $TType_TailleChTab[0], " ", $Var, $TType_TailleChTab[1], ";\n";
  }

  foreach $Var (keys %TTabType) {
    @TType_TailleChTab=split($::SeparDon, $TTabType{$Var});
    print $::SymbFLang $TType_TailleChTab[0], " ", $Var, $TType_TailleChTab[1], ";\n";
  }

} ; # FIN sub EnTete

##########################################################################


sub Ecrire_c_avecTypage {
  my @TPhraz; # Tableau de la PHRAse
  my %TCoresTypeFormat; # Tableau de CORESpondance entre le TYPe et le FORMAT d'affichage
  my $Expr; # EXPRession
  my $PosCrochet; # POSition des CROCHETS
  my $NomTab; # NOM du TABleau
  my $Type;

  @TPhraz=split($::SeparDon, $_[0]);
  %TCoresTypeFormat=("float"=>"%g", "char"=>"%s");

  foreach $Expr (@TPhraz) {

    if (index($Expr, "\"") > -1) {
      print $::SymbFLang "printf(".$Expr.");", "\n";
    }

    else {

      $PosCrochet=index($Expr, "[");

      if ($PosCrochet > -1) {
	$NomTab=substr($Expr, 0, $PosCrochet);
	$Type=(split($::SeparDon, $TTabType{$NomTab}))[0];
      }
      else {
	$Type=(split($::SeparDon, $TVarType{$Expr}))[0];
      } ; # fin_si l'EXPRession est un tableau

      if ($Type eq "") {
	$Type="float";
      } ; # fin_si le type est vide (L'expression n'est pas un nom de variable seul : c'est donc une expression calculable)

      print $::SymbFLang "printf(\"".$TCoresTypeFormat{$Type}."\", ".$Expr.") ;", "\n";

    } ; # Fin_Si l'EXPRession est une chaine de caractres constante

  } ; # FIN_POUR toutes les EXPRessions de la PHRAse

  print $::SymbFLang "printf(\"\\n\") ;";

} ; # FIN sub Ecrire_c_avecTypage


##########################################################################


sub Ecrire__c_avecTypage {
  my @TPhraz; # Tableau de la PHRAse
  my %TCoresTypeFormat; # Tableau de CORESpondance entre le TYPe et le FORMAT d'affichage
  my $Expr; # EXPRession
  my $PosCrochet; # POSition des CROCHETS
  my $NomTab; # NOM du TABleau
  my $Type;

  @TPhraz=split($::SeparDon, $_[0]);
  %TCoresTypeFormat=("float"=>"%g", "char"=>"%s");

  foreach $Expr (@TPhraz) {

    if (index($Expr, "\"") > -1) {
      print $::SymbFLang "printf(".$Expr.");", "\n";
    }

    else {

      $PosCrochet=index($Expr, "[");

      if ($PosCrochet > -1) {
	$NomTab=substr($Expr, 0, $PosCrochet);
	$Type=(split($::SeparDon, $TTabType{$NomTab}))[0];
      }
      else {
	$Type=(split($::SeparDon, $TVarType{$Expr}))[0];
      } ; # fin_si l'EXPRession est un tableau

      if ($Type eq "") {
	$Type="float";
      } ; # fin_si le type est vide (L'expression n'est pas un nom de variable seul : c'est donc une expression calculable)

      print $::SymbFLang "printf(\"".$TCoresTypeFormat{$Type}."\", ".$Expr.") ;", "\n";

    } ; # Fin_Si l'EXPRession est une chaine de caractres constante

  } ; # FIN_POUR toutes les EXPRessions de la PHRAse

} ; # FIN sub Ecrire_c_avecTypage

##########################################################################

sub Lire_c_avecTypage {
  my %TCoresTypeFormat; # Tableau de CORESpondance entre le TYPe et le FORMAT d'affichage
  my $Expr; # EXPRession
  my $PosCrochet; # POSition des CROCHETS
  my $NomTab; # NOM du TABleau

  $Expr=$_[0];

  %TCoresTypeFormat=("float"=>"%g", "char"=>"%s");

  $PosCrochet=index($Expr, "[");

  if ($PosCrochet > -1) {
    $NomTab=substr($Expr, 0, $PosCrochet);
    $Type=(split($::SeparDon, $TTabType{$NomTab}))[0];
  }
  else {
    $Type=(split($::SeparDon, $TVarType{$Expr}))[0];
  } ; # fin_si l'EXPRession est un tableau

  if ($Type eq "float") {
    print $::SymbFLang "scanf(\"".$TCoresTypeFormat{$Type}."\", &".$Expr.");";
  }
  else {
     print $::SymbFLang "gets(".$Expr.") ;";
  }

} ; # FIN sub Lire_c_avecTypage

##########################################################################
##########################################################################


##########################################################################
##
## Fin de programme
##
##########################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :

1;
