#  (gH)   --  galg2perl.pm  ;  TimeStamp (unix) : 20 Juillet 01 22:39
################################################################################################################################
# Auteur : Benot LAURENT & Emmanuel LONG
# Licence informatique
# galg2prl.pm : Module de traduction d'ALGorithme en PERL
# Date : 07/06/2001
#
################################################################################################################################

# Dclarations du package

package galg2perl;
require Exporter;
@ISA=('Exporter');
@EXPORT=(
	 'DebutProgramme_perl',
	 'Commentaire_perl',
	 'Affecter_perl',
	 'Ecrire_perl',
	 'Ecrire__perl',
	 'Ecrire_sur_perl',
	 'Lire_perl',
	 'Lire_sur_perl',
	 'Ouvrir_lec_perl',
	 'Ouvrir_ecr_perl',
	 'Fermer_perl',
	 'Appeler_perl',
	 'Quitter_perl',
	 'Pour_perl',
	 'Fin_Pour_perl',
	 'Si_perl',
	 'Alors_perl',
	 'Sinon_perl',
	 'Fin_Si_perl',
	 'Tant_Que_perl',
	 'Fin_Tant_Que_perl',
	 'Repeter_perl',
	 'Jusqu\'a_perl',
	 'GereOperateur_perl',
	 'GereFonction_perl',
	 'GereVarSimple_perl',
	 'GereVarTableau_perl',
	 'GereChaine_perl',
	 'GereCstNum_perl',
	 'FinProgramme_perl'
	);

##########################################################################

# Modules utiliss

use galgfncs ;

###########################################################################
###########################################################################


###########################################################################
#                                                                         #
#                                                                         #
#        Gestion de DEBUT et FIN de programme                             #
#                                                                         #
#                                                                         #
###########################################################################


###########################################################################
###########################################################################


sub DebutProgramme_perl {

  # il n'y a rien d'obligatoire en Perl pour indiquer
  # le dbut d'un programme

} ; # FIN sub DebutProgramme_perl


##########################################################################


sub FinProgramme_perl {

  # il n'y a rien d'obligatoire en Perl pour indiquer
  # la fin d'un programme ; mais exit peut etre utilis

   print $::SymbFLang "" ;

} ; # FIN sub FinProgramme_perl


###########################################################################
###########################################################################


###########################################################################
#                                                                         #
#                                                                         #
#        Sous-programmes de type INSTRUCTION                              #
#                                                                         #
#                                                                         #
###########################################################################


###########################################################################
###########################################################################


sub Commentaire_perl {

  print $::SymbFLang "#".$_[0];

} ; # FIN sub Commentaire_perl

##########################################################################

sub Affecter_perl {   my $dbg_Aff = 1 ; # 0 pour normal, 1 pour debug


  my $Phraz;
  $Phraz=$_[1];
  my $nPhraz = &convertitExpression_perl( $Phraz ) ;
  #print STDERR "  partir de $_[0] <-- ".$Phraz."\n" ;
  #print STDERR " on traduit en $_[0] = ".$nPhraz." ;\n" ;
  #&attends() ;

  print $::SymbFLang $_[0]." = ".$nPhraz." ;" ;

} ; # FIN sub Affecter_perl

##########################################################################

sub Ecrire_perl {

  my $Phraz;
  $Phraz=$_[0];
  $Phraz=~s/$::SeparDon/." "./g;

  print $::SymbFLang "print ".$Phraz.".\"\\n\" ; ";

} ; # FIN sub Ecrire_perl

##########################################################################

sub Ecrire__perl {

  my $Phraz;
  $Phraz=$_[0];
  $Phraz=~s/$::SeparDon/." "./g;

  print $::SymbFLang "print ".$Phraz." ; ";

} ; # FIN sub Ecrire__perl

##########################################################################

sub Ecrire_sur_perl {

  my $Phraz;
  $Phraz=$_[0];
  $Phraz=~s/$::SeparDon/." "./g;

  print $::SymbFLang "print ".&convertitExpression_perl($_[1])." ".$Phraz.".\"\\n\" ; ";

} ; # FIN sub Ecrire_sur_perl

##########################################################################

sub Lire_perl {

  print $::SymbFLang "chomp(".$_[0]."=<STDIN>) ; ";

} ; # FIN sub Lire_perl

##########################################################################

sub Lire_sur_perl {

  my $lavar = $_[0] ; # identificateur du fichier
  my $idf   = $_[1] ; # identificateur du fichier
  $idf   = &convertitExpression_perl( $idf) ;
  $lavar = &convertitExpression_perl( $lavar) ;

  $lf1 = $lavar." = ".$idf."->getline() ; " ;
  $lf2 = "chomp(".$lavar.") ; " ;
  print $::SymbFLang $lf1."\n" ;
  print $::SymbFLang $lf2 ;

} ; # FIN sub Lire_sur_perl

##########################################################################

sub Ouvrir_lec_perl {

  my $idf = $_[0] ; # identificateur du fichier
  my $pfh = $_[1] ; # "file handle" ou variable de fichier
  $idf  = &convertitExpression_perl( $idf) ;
  $pfh  = &convertitExpression_perl( $pfh) ;
  my $lf1 = $pfh." = new FileHandle ; " ;
  my $lf2 = $pfh."->open(\"<".$idf."\") or die(\" impossible de lire dans $idf\") ; " ;
  print $::SymbFLang $lf1."\n" ;
  print $::SymbFLang $lf2 ;

} ; # FIN sub Ouvrir_lec_perl

##########################################################################

sub Ouvrir_ecr_perl {

  my $idf = $_[0] ; # identificateur du fichier
  my $pfh = $_[1] ; # "file handle" ou variable de fichier
  $idf  = &convertitExpression_perl( $idf) ;
  $pfh  = &convertitExpression_perl( $pfh) ;
  my $lf1 = $pfh." = new FileHandle ; " ;
  my $lf2 = $pfh."->open(\">".$idf."\") or die(\" impossible d'crire dans $idf\") ; " ;
  print $::SymbFLang $lf1."\n" ;
  print $::SymbFLang $lf2 ;

} ; # FIN sub Ouvrir_ecr_perl

##########################################################################

sub Fermer_perl {

  ## print $::SymbFLang "close(".&maju($_[1]).") ; " ;
  my $idf  = &convertitExpression_perl( $_[1]) ;
  print $::SymbFLang $idf."->close() ; " ;

} ; # FIN sub Appeler_perl

##########################################################################

sub Appeler_perl {

  print $::SymbFLang &convertitExpression_perl($_[0])." ; ";

} ; # FIN sub Appeler_perl

##########################################################################

sub Quitter_perl {

  print $::SymbFLang "exit(".$_[0].") ; ";

} ; # FIN sub Appeler_perl

##########################################################################

sub Pour_perl {
  my $partieInit  =  &convertitExpression_perl( $_[1] ) ;
#print " en fin : $_[2] \n" ;
  my $partieFin   =  &convertitExpression_perl( $_[2] ) ;
#print " qui devient : $partieFin \n" ; &attends() ;
  print $::SymbFLang "for ( $_[0] = $partieInit ;  $_[0] <= $partieFin ; $_[0]"."++ ) { " ;
} ; # FIN sub Fin_Pour_perl

##########################################################################

sub Fin_Pour_perl {

  print $::SymbFLang "\} ; ";

} ; # FIN sub Fin_Pour_perl

##########################################################################

sub Si_perl {

  print $::SymbFLang "if (".&convertitExpression_perl( $_[0] ).") { ";

} ; # FIN sub Si_perl

##########################################################################

sub Alors_perl {

} ; # FIN sub Alors_perl

##########################################################################

sub Sinon_perl {

  print $::SymbFLang "}\n else { ";

} ; # FIN sub Sinon_perl

##########################################################################

sub Fin_Si_perl {

  print $::SymbFLang "\} ; ";

} ; # FIN sub Fin_Si_perl

##########################################################################

sub Tant_Que_perl {

  print $::SymbFLang "while (".&convertitExpression_perl( $_[0] ).") { ";

} ; # FIN sub Tant_Que_perl

##########################################################################

sub Fin_Tant_Que_perl {

  print $::SymbFLang "\} ; ";

} ; # FIN sub Fin_Tant_Que_perl

##########################################################################

sub Repeter_perl {

  print $::SymbFLang "do \{ ; ";

} ; # FIN sub Fin_Tant_Que_perl

##########################################################################


sub Jusqu'a_perl {

  print $::SymbFLang "\} until ".&convertitExpression_perl( $_[0] )." ; ";

} ; # FIN sub Fin_Tant_Que_perl

##########################################################################

##########################################################################
##
##  Fonctions de gestion des paramtres
##
##########################################################################

##########################################################################

sub GereOperateur_perl {
  my $ExprD; # EXPRession Droite
  my $Op; # OPrateur
  my $ExprG; # EXPRession Gauche
  my %TCoresOp; # Tableau de CORrESpondance des Oprateurs

  $ExprD=$_[0];
  $Op=$_[1];
  $ExprG=$_[2];

  # Initialisation du Tableau de CORrESpondance des Oprateurs
  $TCoresOp{"_OU_"}=" or ";
  $TCoresOp{"_ET_"}=" and ";
  $TCoresOp{"_NON_"}=" not ";
  $TCoresOp{"_INFEGAL_"}=" <= ";
  $TCoresOp{"_SUPEGAL_"}=" >= ";
  $TCoresOp{"_DIFF_"}=" != ";
  $TCoresOp{"_EGAL_"}=" == ";
  $TCoresOp{"_INF_"}=" < ";
  $TCoresOp{"_SUP_"}=" > ";
  $TCoresOp{"_PLUS_"}=" + ";
  $TCoresOp{"_MOINS_"}=" - ";
  $TCoresOp{"_MULT_"}=" * ";
  $TCoresOp{"_DIV_"}=" / ";

  # Traduction de l'oprateur en Perl
  $Op=$TCoresOp{$Op} ;

  return($ExprD.$Op.$ExprG);

} ; # FIN sub GereOperateur_perl

##########################################################################

sub GereFonction_perl {
  my  $Param;
  my  $nomF ;
  $nomF =$_[0];
  $Param=$_[1];

  # on traite  part fin_de_fichier

  if ($nomF ne "fin_de_fichier") {
      $Param=~s/$::SeparDon/, /g;
      $Param= &convertitExpression_perl($Param) ;
      $retour = "&".$_[0]."( $Param )" ;
  } else {
     $retour = $Param."->eof() " ;
  } ; # fin de si

  return($retour) ;

} ; # FIN sub GereFonction_perl

##########################################################################

sub GereVarSimple_perl {

  return("\$".$_[0]);

} ; # FIN sub GereVarSimple_perl

##########################################################################

sub GereVarTableau_perl {
  my  $Param;

  $Param=$_[1];

  $Param=~s/$::SeparDon/ \]\[ /g;


  return("\$".$_[0]."[ ".$Param." ]");

} ; # FIN sub GereVarTableau_perl

##########################################################################

sub GereChaine_perl {

  return("\"".$_[0]."\"");

} ; # FIN sub GereChaine_perl

##########################################################################

sub GereCstNum_perl {

  return($_[0]);

} ; # FIN sub GereCstNum_perl

##########################################################################

 sub  convertitExpression_perl  { my $dbg_cvE = 1 ; # 0 pour normal, 1 pour debug

  # ce sous-programme convertit les oprateurs internes
  # en oprateurs du langage

  my $l_expression = $_[0] ;

  $l_expression =~ s/_OU_/ or /g ;
  $l_expression =~ s/_ET_/  and /g ;
  $l_expression =~ s/_NON_/ not /g ;
  $l_expression =~ s/_INFEGAL_/ <= /g  ;
  $l_expression =~ s/_SUPEGAL_/ >= /g  ;
  $l_expression =~ s/_DIFF_/ <> /g ;
  $l_expression =~ s/_EGAL_/ == /g   ;
  $l_expression =~ s/_INF_/ < /g   ;
  $l_expression =~ s/_SUP_/ > /g   ;
  $l_expression =~ s/_PLUS_/ + /g   ;
  $l_expression =~ s/_MOINS_/ - /g   ;
  $l_expression =~ s/_MULT_/ * /g   ;
  $l_expression =~ s!_DIV_! / !g   ;

  # on rajoute aussi des espaces pour les oprateurs normaux :
  # devrait ^etre gr plus finement ?? "a-b" ne doit pas devenir "a - b" ???

  $l_expression =~ s!-! - !g   ;
  $l_expression =~ s!\+! + !g   ;
  $l_expression =~ s!\*! * !g   ;

  # il reste  rajouter le symbole $ devant chaque variable connue

  my $newExpr = "" ;
  my $subExp = "" ;
  foreach $subExp (split(" ",$l_expression)) {
    my $cntExp = index(" $main::lstVars $main::lstFic "," $subExp ") ;
#print STDERR " on traite $subExp dont l'index est $cntExp \n" ;
    if ($cntExp>-1) { $nsubExpr = "\$".$subExp." "  } else { $nsubExpr = $subExp." " } ;
#print STDERR " on en fait $nsubExpr \n" ;
    $newExpr .= $nsubExpr ;
  } ; # fin pour chaque sous-expression

#  print " avant : $l_expression \n"  ;
#  print " aprs : $newExpr \n"  ;
#&attends() ;

  # il faut juste remettre -> en place pour les appels objets

  $newExpr =~ s!- >! -> !g   ;
  $newExpr =~ s! ->!->!g   ;

  return( $newExpr ) ;

} ; # fin sub convertitExpression_perl


##########################################################################

# cette dernire ligne est obligatoire pour dire que le chargement est ok :

1 ;
